;; -*- mode: emacs-lisp; coding: hebrew-iso-8bit-unix -*-

;;
;;              EHUD   KARNI               
;;              Ben Gurion st'   14     '
;;              Kfar - Sava    44 257      - 
;;              ===================================
;;              ehud@unix.mvs.co.il   972-9-7659599
;;              ===================================

(defconst Alef-Unix  #xE0  "Place of Alef (Hebrew 1st letter) on UNIX system")

;;  (setq standard-display-table nil)                  ;; for restarting display table

;;  (set-locale-environment "he_IL")                   ;; ensure Hebrew environment

(defun display-hebrew (&optional unix-dos)
  "change standard display tab for Hebrew. An optional parameter UNIX-DOS
may be \"UNIX\" (Hebrew in 224-250) or \"DOS\" (Hebrew in 128-154).
Any value which is not \"dos\" or \"DOS\" is UNIX (and WINDOZ)."
       (interactive "sselect operating system (UNIX or DOS): ")
       (if (not unix-dos)
           (setq unix-dos "UNIX"))
       (setq Alef-is (if (string-equal (upcase unix-dos) "DOS")
                         128 Alef-Unix))
       (setq Tav-is (+ Alef-is 26))                    ;; Tav in this Hebrew display
       (let* ((beg (- 352 Alef-is))                    ;; beginning of other Hebrew (the one with a prefix)
              (dif (- beg Alef-is))                    ;; difference between the 2 Hebrews
              (heb (decode-char 'iso-8859-8 Alef-Unix));; Aleph in UTF Hebrew
              (cnt 27)                                 ;; UNIX/WINDOWS  - Hebrew in 0xE0-0xFA (224-250)
              (alef beg)                               ;; other alef
              (tav  (+ Tav-is dif))                    ;; other tav
              (prfx (if window-system                  ;; use different prefix for TTY/X
                            172 169))                  ;; PC (MSDOS), TTY = 169, real X=172
              (grfc 179)                               ;; 1st DOS (cp862) graphic character
              )

           (or standard-display-table
               (setq standard-display-table (make-display-table)))
           ;;  (standard-display-8bit 128 254)

           (while (> cnt 0)
               (aset standard-display-table (- beg dif) (vector heb))  ;;  for normal char
               (aset standard-display-table (unibyte-char-to-multibyte (- beg dif)) (vector heb))  ;; for "literally"
               (aset standard-display-table beg (vector prfx heb))
               (aset standard-display-table (unibyte-char-to-multibyte beg) (vector prfx heb))
               (aset standard-display-table heb (vector heb))
               (setq heb (1+ heb))
               (setq beg (1+ beg))
               (setq cnt (1- cnt)))
           (aset standard-display-table 160 (vector prfx prfx))
           (aset standard-display-table #xFD (vector #x200E))   ;;LRM
           (aset standard-display-table #x0C7D (vector #x200E))   ;;LRM
           (aset standard-display-table #x0C7E (vector #x200F))   ;;RLM
           (aset standard-display-table #xFE (vector #x200F))   ;;RLM

           (while (> Alef-Unix grfc)                       ;; do for all DOS (cp862) graphic characters
               (aset standard-display-table grfc (vector
                     (if window-system
                         (decode-char 'cp862 grfc)         ;; use UTF of this graphic on X
                         grfc)))                           ;; use the char itself for PC/TTY    190-223 = ?
               (aset standard-display-table (unibyte-char-to-multibyte grfc)
                     (aref standard-display-table grfc))
               (setq grfc (1+ grfc)))
           ))


(defun chars-list ()
 "display all characters in range 0x20-0xFF"
   (interactive)
       (if (get-buffer "*Help*")
           (kill-buffer "*Help*"))
       (let ((ch 32)
             (svbuf (buffer-name))
             (standard-output (get-buffer-create "*Help*")))
           (set-buffer standard-output)
           (pop-to-buffer standard-output)
           (delete-region (point-min) (point-max))
           (princ " List of all displayable characters:\n\n")
           (while (< ch 88)
               (let ((c ch))
                   (while (< c 256)
                       (princ (format " [%c]=%3dD,%3oO,%2xX"  c c c c))
                       (setq c (+ c 56))
                       (if (< c 256)
                           (princ "  "))))
               (princ "\n")
               (setq ch (1+ ch)))
           (goto-char (point-min))
           (pop-to-buffer svbuf)))

;;========================= end of test-heb.el =========================
